// CV9a.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <string.h>
#include "seznam.h"

#define fname "pel_10.csv"
#define lgbuf 300

listDescr data = { NULL };  

int radek(char s[]);
void cetnost1(listDescr *list);
void cetnost2(listDescr *list);
void cetnost3(listDescr *list);
void prumerzip(listDescr *list);

int _tmain(int argc, _TCHAR* argv[])
{
   char buf[lgbuf];
   FILE *fr;
   int radku=0;
   int n;
   char *pok;
   
   fr=fopen(fname, "rt");
   if (fr==NULL)
   {
     printf("Soubor %s nenalezen.\n", fname);
     return 1;
   }
   pok=fgets(buf, lgbuf-1, fr);
   while (pok)
   {
     radku++;
     n=radek(buf);
     if ((radku>1)&&(n==12))
     {
 //      printf("%d %s", n, buf);
       listAdd(&data, buf);
     }  
     pok=fgets(buf, lgbuf-1, fr);
   }
   fclose(fr);
   listShow(&data);
   printf("Nacteno %d radku\n", radku);
   cetnost1(&data);
   putchar('\n');
   cetnost2(&data);
   prumerzip(&data);
   cetnost3(&data);
   listClear(&data);   
   return 0;
}

int radek(char s[])
{
   char bf[300];
   char *cp;
   strcpy(bf, s);
   int n=0;	
   cp=strtok(bf, TOKEN_DELIMS);
   while (cp)
   {
    n++;
    cp=strtok(NULL, TOKEN_DELIMS);
   } 
   return n;
}

int stateval(char *s)
{
 return s[1]-'A'+26*(s[0]-'A');
} 

void cetnost1(listDescr *list)
{
 int ct[26*26];
 item *tmp;
 int i;
 memset(ct, 0, sizeof(ct));
 for (tmp=list->first;tmp;tmp=tmp->next)
   ct[stateval(tmp->state)]++;
 for (i=0;i<26*26;i++)
   if (ct[i]!=0) printf("%c%c %3d\n", (i/26)+'A', (i%26)+'A', ct[i]);
}  

#define MXST 52

void cetnost2(listDescr *list)
{
 int ct[MXST];
 char st[MXST][3];
 int mx=0;
 item *tmp;
 int i;
 memset(ct, 0, sizeof(ct));
 memset(st, 0, sizeof(st));
 for (tmp=list->first;tmp;tmp=tmp->next)
 {
   for (i=0;i<mx;i++)
	if (strcmp(tmp->state, st[i])==0)
		{
		ct[i]++;
		break;
		}
   if ((i>=mx)&&(i<MXST-1))
	{
	 strcpy(st[mx], tmp->state);
	 ct[mx]=1;
	 mx++;
	}
 }	  		
 for (i=0;i<mx;i++)
	printf("%s %3d\n", st[i], ct[i]);		
}  

int myatoi(char *s)
{
 int vysl=0;
 while (*s)
	{
	 switch(*s)
	 {
	  case '0':
	  case '1':
	  case '2':
	  case '3':
	  case '4':
	  case '5':
	  case '6':
	  case '7':
	  case '8':
	  case '9': vysl=10*vysl+(*s-'0');
	  break;
	  default: return -999999;
	 }
	 s++;
	}
 return vysl;
}
 
void prumerzip(listDescr *list)
{
 double sum=0;
 int n=0;
 item *tmp;
 for (tmp=list->first;tmp;tmp=tmp->next)
 {
	sum+=myatoi(tmp->zip);
	n++;
 }
 if (n) sum/=n;
 printf("\nPrumer ZIP je %0.2f z %d polozek.\n", sum, n);	
}  

void cetnost3(listDescr *list)
{
 int ct[26*26];
 int ind[26*26];
 item *tmp;
 int i,j,n;
 bool ok;
 memset(ct, 0, sizeof(ct));
 for (tmp=list->first;tmp;tmp=tmp->next)
   ct[stateval(tmp->state)]++;
   
 j=0; n=1;
 do {
 ok=false;
 for (i=26*26-1;i>=0;i--)
	{
	 if (ct[i]==n) ind[j++]=i;
	 if (ct[i]>n) ok=true;
	}
  n++;	
 } while(ok);
   
 for (i=j-1;i>=0;i--)
   printf("%c%c %3d\n", (ind[i]/26)+'A', (ind[i]%26)+'A', ct[ind[i]]);
}  
