#ifndef __seznam_h

#define __seznam_h

#include <string.h>
#include <stdlib.h>

#define WORKING_COLUMNS 8
#define TOKEN_DELIMS  "\r\n\t;"

typedef struct _item_struct
{
  char *first_name;
  char *last_name;
  char *company_name;
  char *address;
  char *city;
  char *county;
  char *state;
  char *zip;
  _item_struct *next;
} item;

typedef struct
{
  item *first;
} listDescr;

bool listAdd(listDescr *list, char *txt);
void listShow(listDescr *list);
bool listClear(listDescr *list);
bool freeItem(item *x);
item *createItemFromLime(char *txt);
char *allocVal(char *src);

typedef char *pchar;
typedef pchar *ppchar;

#endif
